#MVP设计说明
名词缩写解析：
f:Fragment
a:Activity
p:MVP的P
v:MVP的V
##设计思考过程
一般的mvp是把f/a作为view的，但是参考了[一种在android中实现MVP模式的新思路](https://github.com/bboyfeiyu/android-tech-frontier/tree/master/androidweekly/%E4%B8%80%E7%A7%8D%E5%9C%A8android%E4%B8%AD%E5%AE%9E%E7%8E%B0MVP%E6%A8%A1%E5%BC%8F%E7%9A%84%E6%96%B0%E6%80%9D%E8%B7%AF)
发现，的确p中可能更多地需要context，而不是v需要context。所以我们f/a 作为p

然后f的生命周期实在太复杂，而且容易出错！在这方面，Square是反Fragment的带头大哥,参考了Mortar和Flow,但是发现Square的类库，还不是发布版本，而且给出的例子也有bug。
所以还是用回Fragment，但由此引发思考:p作为业务逻辑的处理，为什么要和f/a的生命周期挂钩？一个业务逻辑的处理，去除界面耦合，那就应该是一个后台任务啊。

这时再来思考f/a究竟是什么。
1. f/a是view的容器
2. f/a作为内存回收资源的单元
3. f/a提供一个god object，万能的Context
我们关注到第二点，android资源如果到阀值，f/a的资源是会被回收的。在这点上，Square的Flow是更积极的回收方式，当View不在前台时，马上释放
基于以上三点，对任务Task重新思考。Task：一项功能或任务，譬如支付，譬如抢红包
如果p并不是一个task，而是task由多个p和v组成呢？
也就是说，p&v只是task的一个操作步骤，这样设计的话，就符合android本来的逻辑了。我们技术关注的，就应该是各个p之间的通讯，如提前加载之类的

##我们的设计
1. p is a f/a
2. v has a p
3. define observer in a p
4. v is a observer of p
5. p has an observer
6. we suggest that p is statful
首先 p是 f/a的话，p就可以在生命周期函数保存自己的状态，所以我们建议p is stateful
2. view要调用p，所以view has a p
3. v调用p，很多情况是异步的，譬如网络加载数据，所以p要暴露一个observer(观察者模式)，告诉v有情况，所以4. v is a observer of p和5. p has an observer
由于EventBug这些不利于测试，所以不用
6. 只是建议，如果v是基于状态而改变界面的，p最好是stateful，而且我们已经有State这个类。

具体参考example
参考文章：

[一种在android中实现MVP模式的新思路](https://github.com/bboyfeiyu/android-tech-frontier/tree/master/androidweekly/%E4%B8%80%E7%A7%8D%E5%9C%A8android%E4%B8%AD%E5%AE%9E%E7%8E%B0MVP%E6%A8%A1%E5%BC%8F%E7%9A%84%E6%96%B0%E6%80%9D%E8%B7%AF)

[Flow和Mortar的调查](https://github.com/bboyfeiyu/android-tech-frontier/tree/master/androidweekly/Square%20%E5%BC%80%E6%BA%90%E5%BA%93Flow%E5%92%8CMortar%E7%9A%84%E4%BB%8B%E7%BB%8D)

[MVP在Android平台上的应用](https://github.com/bboyfeiyu/android-tech-frontier/blob/master/issue-12/Android%E4%B8%8AMVP%E7%9A%84%E4%BB%8B%E7%BB%8D.md)

[Square：从今天开始抛弃Fragment吧](https://github.com/bboyfeiyu/android-tech-frontier/blob/master/issue-13/Square%EF%BC%9A%E4%BB%8E%E4%BB%8A%E5%A4%A9%E5%BC%80%E5%A7%8B%E6%8A%9B%E5%BC%83Fragment%E5%90%A7%EF%BC%81.md)

[为什么你应该停止使用EventBus](https://github.com/bboyfeiyu/android-tech-frontier/blob/master/issue-16/%E4%B8%BA%E4%BB%80%E4%B9%88%E4%BD%A0%E5%BA%94%E8%AF%A5%E5%81%9C%E6%AD%A2%E4%BD%BF%E7%94%A8EventBus.md)